#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "_reduce_method_descriptor4xi.py">
#<abstract4xi abstract = "providing function _reduce_method_descriptor4xi"/>
#<refer4xi reference = "forking.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = ['_reduce_method_descriptor4xi'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # winapi
    import _winapi
    from _winapi import WAIT_OBJECT_0, WAIT_TIMEOUT, INFINITE
except ImportError:
    if sys.platform == 'win32':
        raise
    _winapi = None
try:
    from functools import partial
except ImportError:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
from multiprocessing import forking
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from forkingpickler4xi import ForkingPickler4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "reduce-method-descriptor4xi" usage = "
#   forking.py
#       ForkingPickler.register(type(list.append), _reduce_method_descriptor)   
#       ForkingPickler.register(type(list.append), _reduce_method_descriptor)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def _reduce_method_descriptor4xi(m):
    '''
    reduces method descriptor
    ''' 
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    class2print = "_reduce_method_descriptor4xi"
    method2print = "_reduce_method_descriptor4xi"
   
    
    message2print = "{started" + "; reduce-method-descriptor4xi-started: " + str(_reduce_method_descriptor4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 

    message2print = "{passed" + "; method-passed-to-reduce-method-descriptor4xi: " + str(m) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    message2print = "{passing" + "; method-objectclass-passing-to-getattr-by-reduce-method-descriptor4xi: " + str(m.__objclass__) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
    message2print = "{passing" + "; method-name-passing-to-getattr-by-reduce-method-descriptor4xi: " + str(m.__name__) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)              

    message2print = "{returning" + "; getattr-function-returning-by-reduce-method-descriptor4xi: " + str(getattr) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
            
           
    return getattr, (m.__objclass__, m.__name__)    
    
#</function4xi>


# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ForkingPickler4Xi.register(type(list.append), _reduce_method_descriptor4xi)
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ForkingPickler4Xi.register(type(int.__add__), _reduce_method_descriptor4xi)
#"
#"/>



#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_reduce_method_descriptor4xi.txt
#   sense-test-reduce-method-descriptor4xi.xml
#   reason-test-reduce-method-descriptor4xi.xml
#   ace-test-reduce-method-descriptor4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of _reduce_method_descriptor4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
